<?php


namespace FiloBlu\Referrals\Plugin\Magento\Invitation\Model;

use Magento\Invitation\Model\Invitation\Status;

class Invitation
{
    /**
     * @var \FiloBlu\Referrals\Helper\Email
     */
    protected $_referralEmail;

    /**
     * @var \FiloBlu\Referrals\Helper\Core
     */
    protected $_coreHelper;

    /**
     * @var \Magento\Newsletter\Model\SubscriberFactory
     */
    protected $_subscriberFactory;

    public function __construct(
        \FiloBlu\Referrals\Helper\Email $referralEmail,
        \FiloBlu\Referrals\Helper\Core $coreHelper,
        \Magento\Newsletter\Model\SubscriberFactory $subscriberFactory
    )
    {
        $this->_referralEmail = $referralEmail;
        $this->_coreHelper = $coreHelper;
        $this->_subscriberFactory = $subscriberFactory;
    }

    public function afterAccept(
        \Magento\Invitation\Model\Invitation $subject,
        $result,
        $websiteId,
        $referralId
    ) {
        $status_accepted = Status::STATUS_ACCEPTED;
        $status = $result->getStatus();
        if ($status == $status_accepted){
            $sended = $this->_referralEmail->notify_invitation_receiver_by_referral_id($referralId);

            $couponInvitationType = $this->_coreHelper->getSysConfigValue($this->_coreHelper::COUPON_FIELD_INVITATION_TYPE);

            if ($couponInvitationType !== 'site') {
                $subscriber = $this->_subscriberFactory->create()->loadByEmail($subject->getEmail());
                $subject->setNewsletterReferralId($subscriber->getSubscriberId());
                $subject->save();
            }
        }
        return $result;
    }
}